diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/channel_mode.c ircd-hybrid-fuis/src/channel_mode.c
--- ircd-hybrid-7.0rc9/src/channel_mode.c	Thu Feb  6 05:12:39 2003
+++ ircd-hybrid-fuis/src/channel_mode.c	Sun May  4 18:18:40 2003
@@ -44,7 +44,7 @@
 #include "event.h"
 #include "memory.h"
 #include "balloc.h"
-
+#include "resv.h"
 
 #include "s_log.h"
 
@@ -495,6 +495,18 @@
     *mbuf++ = 'i';
   if (chptr->mode.mode & MODE_NOPRIVMSGS)
     *mbuf++ = 'n';
+  if (chptr->mode.mode & MODE_NOCOLOR)
+    *mbuf++ = 'c';
+  if (chptr->mode.mode & MODE_NOTALK)
+    *mbuf++ = 'M';
+  if (chptr->mode.mode & MODE_NOSPAM)
+    *mbuf++ = 'H';
+  if (chptr->mode.mode & MODE_NOREPEAT)
+    *mbuf++ = 'z';
+  if (chptr->mode.mode & MODE_NOCTCP)
+    *mbuf++ = 'C';
+  if (chptr->mode.mode & MODE_JOINF)
+    *mbuf++ = 'q';
 #ifdef ANONOPS
   if (chptr->mode.mode & MODE_HIDEOPS)
     *mbuf++ = 'a';
@@ -690,6 +702,7 @@
 #define SM_ERR_RESTRICTED       0x00000080      /* Restricted chanop */
 #define SM_ERR_RPL_I            0x00000100
 #define SM_ERR_RPL_D            0x00000200
+#define SM_ERR_SERVICESNICK     0x00000400
 
 /* Now lets do some stuff to keep track of what combinations of
  * servers exist...
@@ -808,6 +821,7 @@
            const char *chname)
 {
   long mode_type;
+  int admin = 0;
 
   mode_type = (long)d;
 
@@ -817,11 +831,15 @@
   if((alev < CHACCESS_HALFOP) ||
     ((mode_type == MODE_PRIVATE) && (alev < CHACCESS_CHANOP)))
   {
-    if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
-                 source_p->name, chname);
-    *errors |= SM_ERR_NOOPS;
-    return;
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
+  	  if (!(*errors & SM_ERR_NOOPS))
+    	sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+              	   source_p->name, chname);
+  	  *errors |= SM_ERR_NOOPS;
+  	  return;
+	}
   }
 
   /* If have already dealt with this simple mode, ignore it */
@@ -834,6 +852,9 @@
   {
     chptr->mode.mode |= mode_type;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set +%c on %s", source_p->name, c, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_ADD;
     mode_changes[mode_count].caps = 0;
@@ -848,6 +869,9 @@
 
     chptr->mode.mode &= ~mode_type;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set -%c on %s", source_p->name, c, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_DEL;
     mode_changes[mode_count].caps = 0;
@@ -869,16 +893,22 @@
    * have the capab if we support it, so we should never get
    * here for a remote server if we dont support it..
    */
+  int admin = 0;
+
   if(!ConfigChannel.use_anonops)
     return;
 
   if (alev < CHACCESS_HALFOP)
   {
-    if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
-                 source_p->name, chname);
-    *errors |= SM_ERR_NOOPS;
-    return;
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
+  	  if (!(*errors & SM_ERR_NOOPS))
+    	sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+            	   source_p->name, chname);
+	  *errors |= SM_ERR_NOOPS;
+	  return;
+	}
   }
 
   if (MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
@@ -892,6 +922,9 @@
   {
     chptr->mode.mode |= MODE_HIDEOPS;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set hideops on %s", source_p->name, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_ADD;
     mode_changes[mode_count].caps = CAP_AOPS;
@@ -904,6 +937,9 @@
   {
     chptr->mode.mode &= ~MODE_HIDEOPS;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to unset hideops on %s", source_p->name, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_DEL;
     mode_changes[mode_count].caps = CAP_AOPS;
@@ -925,6 +961,7 @@
   char *raw_mask;
   dlink_node *ptr;
   struct Ban *banptr;
+  int admin = 0;
 
   if (dir == 0 || parc <= *parn)
   {
@@ -955,24 +992,30 @@
     return;
   }
 
-  if (alev < CHACCESS_HALFOP)
-  {
-    if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
-                 source_p->name, chname);
-    *errors |= SM_ERR_NOOPS;
-    return;
-  }
 
   if (MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
     return;
 
+  if (alev < CHACCESS_HALFOP)
+  {
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
+  	  if (!(*errors & SM_ERR_NOOPS))
+    	sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+              	   source_p->name, chname);
+	  *errors |= SM_ERR_NOOPS;
+  	  return;
+	}
+  }
+
   raw_mask = parv[(*parn)++];
   
   if (IsServer(client_p))
     mask = raw_mask;
   else
     mask = pretty_mask(raw_mask);
+
     
   /* if we're adding a NEW id */
   if (dir == MODE_ADD) 
@@ -980,6 +1023,9 @@
     if((add_id(source_p, chptr, mask, CHFL_BAN) == 0) && MyClient(source_p))
       return;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to ban %s on %s", source_p->name, mask, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_ADD;
     mode_changes[mode_count].caps = 0;
@@ -990,9 +1036,13 @@
   }
   else if (dir == MODE_DEL)
   {
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to unban %s on %s", source_p->name, mask, chptr->chname);
+
 /* XXX grrrrrrr */
 #ifdef NO_BAN_COOKIE
 
+
     if (del_id(chptr, mask, CHFL_BAN) == 0)
     {
       /* mask isn't a valid ban, check raw_mask */
@@ -1033,6 +1083,7 @@
   dlink_node *ptr;
   struct Ban *banptr;
   char *mask, *raw_mask;
+  int admin = 0;
 
   /* if we have +e disabled, allow local clients to do anything but
    * set the mode.  This prevents the abuse of +e when just a few
@@ -1050,11 +1101,15 @@
 
   if (alev < CHACCESS_HALFOP)
   {
-    if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
-                 source_p->name, chname);
-    *errors |= SM_ERR_NOOPS;
-    return;
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
+  	  if (!(*errors & SM_ERR_NOOPS))
+    	sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+                   source_p->name, chname);
+  	  *errors |= SM_ERR_NOOPS;
+	  return;
+	}
   }
 
   if ((dir == MODE_QUERY) || parc <= *parn)
@@ -1063,6 +1118,9 @@
       return;
     *errors |= SM_ERR_RPL_E;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to see the exception list on %s", source_p->name, chptr->chname);
+
     DLINK_FOREACH(ptr, chptr->exceptlist.head)
     {
       banptr = ptr->data;
@@ -1084,12 +1142,16 @@
   else
     mask = pretty_mask(raw_mask);
 
+
   /* If we're adding a NEW id */
   if (dir == MODE_ADD)
   {
     if((add_id(source_p, chptr, mask, CHFL_EXCEPTION) == 0) && MyClient(source_p))
       return;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set +e %s on %s", source_p->name, mask, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_ADD;
     mode_changes[mode_count].caps = CAP_EX;
@@ -1105,6 +1167,9 @@
   }
   else if (dir == MODE_DEL)
   {
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to unset +e %s on %s", source_p->name, mask, chptr->chname);
+
     if (del_id(chptr, mask, CHFL_EXCEPTION) == 0)
     {
       /* mask isn't a valid ban, check raw_mask */
@@ -1135,6 +1200,7 @@
   char *mask, *raw_mask;
   dlink_node *ptr;
   struct Ban *banptr;
+  int admin = 0;
 
   /* if we have +I disabled, allow local clients to do anything but
    * set the mode.  This prevents the abuse of +I when just a few
@@ -1152,11 +1218,15 @@
 
   if (alev < CHACCESS_HALFOP)
   {
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
+	}
   }
 
   if ((dir == MODE_QUERY) || parc <= *parn)
@@ -1165,6 +1235,9 @@
       return;
     *errors |= SM_ERR_RPL_I;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to see the invex list on %s", source_p->name, chptr->chname);
+
     DLINK_FOREACH(ptr, chptr->invexlist.head)
     {
       banptr = ptr->data;
@@ -1186,11 +1259,15 @@
   else
     mask = pretty_mask(raw_mask);
 
+
   if(dir == MODE_ADD)
   {
     if((add_id(source_p, chptr, mask, CHFL_INVEX) == 0) && MyClient(source_p))
       return;
 
+  if (admin)
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set +I %s on %s", source_p->name, mask, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_ADD;
     mode_changes[mode_count].caps = CAP_IE;
@@ -1206,6 +1283,9 @@
   }
   else if (dir == MODE_DEL)
   {
+  if (admin)
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set -I %s on %s", source_p->name, mask, chptr->chname);
+
     if (del_id(chptr, mask, CHFL_INVEX) == 0)
     {
       /* mask isn't a valid ban, check raw_mask */
@@ -1254,17 +1334,23 @@
   int wasnt_voiced = 0, t_op, t_hop, t_voice;
   char *opnick;
   struct Client *targ_p;
+  struct ResvNick *resv;
+  int admin = 0;
 #ifdef HALFOPS
   int wasnt_hopped = 0;
 #endif
 
   if (alev < CHACCESS_CHANOP)
   {
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
+	}
   }
 
   if ((dir == MODE_QUERY) || (parc <= *parn))
@@ -1283,6 +1369,7 @@
 
   opnick = parv[(*parn)++];
 
+
   if ((targ_p = find_chasing(source_p, opnick, NULL)) == NULL)
   {
     return;
@@ -1297,6 +1384,15 @@
     return;
   }
 
+  if (MyClient(source_p) && (resv = return_nick_resv(opnick)) && !irccmp(resv->reason, ConfigFileEntry.services_qline))
+  {
+    if (!(*errors & SM_ERR_SERVICESNICK))
+      sendto_one(source_p, form_str(ERR_SERVICESNICKHOP), me.name,
+                 source_p->name, chname);
+    *errors |= SM_ERR_SERVICESNICK;
+    return;
+  }
+
   mode_get_status(chptr, targ_p, &t_op, &t_hop, &t_voice, 1);
 
   if (((dir == MODE_ADD) && t_op) ||
@@ -1341,6 +1437,9 @@
   if (dir == MODE_ADD)
   {
 
+  if (admin)
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set +o %s on %s", source_p->name, targ_p->name, chptr->chname);
+
 #ifndef REQUIRE_OANDV
     if (!wasnt_voiced && t_voice)
     {
@@ -1379,6 +1478,9 @@
   }
   else
   {
+  if (admin)
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set -o %s on %s", source_p->name, targ_p->name, chptr->chname);
+
 #ifdef HALFOPS
     /* Converting -o to -h... */
     if (t_hop)
@@ -1439,9 +1541,10 @@
            char **parv, int *errors, int alev, int dir, char c, void *d,
            const char *chname)
 {
-  int i, wasnt_voiced = 0, t_voice, t_op, t_hop;
+  int i, wasnt_voiced = 0, t_voice, t_op, t_hop, admin = 0;
   char *opnick;
   struct Client *targ_p;
+  struct ResvNick *resv;
 
   /* halfops have been disabled.. disallow local users to set,
    * remote is taken care of via BOUNCE_BAD_HOPS, and we shouldnt
@@ -1467,11 +1570,15 @@
       ((chptr->mode.mode & MODE_PRIVATE) ?
         CHACCESS_CHANOP : CHACCESS_HALFOP))
   {
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
+	}
   }
 
   if ((dir == MODE_QUERY) || parc <= *parn)
@@ -1482,6 +1589,7 @@
 
   opnick = parv[(*parn)++];
 
+
   if ((targ_p = find_chasing(source_p, opnick, NULL)) == NULL)
   {
     return;
@@ -1522,6 +1630,15 @@
   }
 #endif
 
+  if (MyClient(source_p) && (resv = return_nick_resv(opnick)) && !irccmp(resv->reason, ConfigFileEntry.services_qline))
+  {
+    if (!(*errors & SM_ERR_SERVICESNICK))
+      sendto_one(source_p, form_str(ERR_SERVICESNICKHOP), me.name,
+                 source_p->name, chname);
+    *errors |= SM_ERR_SERVICESNICK;
+    return;
+  }
+
   /* Cancel out all other mode changes... */
   for (i = 0; i < mode_count; i++)
     if (mode_changes[i].dir == MODE_ADD &&
@@ -1540,6 +1657,10 @@
 
   if (dir == MODE_ADD)
   {
+
+  if (admin)
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set +h %s on %s", source_p->name, targ_p->name, chptr->chname);
+
     if (!wasnt_voiced && t_voice)
     {
       mode_changes[mode_count].letter = 'v';
@@ -1574,6 +1695,10 @@
   }
   else 
   { /* MODE_DEL */
+
+  if (admin)
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set -h %s on %s", source_p->name, targ_p->name, chptr->chname);
+
     mode_changes[mode_count].letter = 'h';
     mode_changes[mode_count].dir = MODE_DEL;
     mode_changes[mode_count].caps = CAP_HOPS;
@@ -1603,17 +1728,21 @@
           char **parv, int *errors, int alev, int dir, char c, void *d,
           const char *chname)
 {
-  int i, t_op, t_hop, t_voice;
+  int i, t_op, t_hop, t_voice, admin = 0;
   char *opnick;
   struct Client *targ_p;
 
   if (alev < CHACCESS_HALFOP)
   {
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
+	}
   }
 
   if ((dir == MODE_QUERY) || parc <= *parn)
@@ -1621,6 +1750,7 @@
 
   opnick = parv[(*parn)++];
 
+
   if ((targ_p = find_chasing(source_p, opnick, NULL)) == NULL)
   {
     return;
@@ -1653,6 +1783,10 @@
 
   if (dir == MODE_ADD)
   {
+
+  if (admin)
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set +v %s on %s", source_p->name, targ_p->name, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_ADD;
     mode_changes[mode_count].caps = 0;
@@ -1674,6 +1808,9 @@
       }
     }
 
+  if (admin)
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set -v %s on %s", source_p->name, targ_p->name, chptr->chname);
+
     mode_changes[mode_count].letter = 'v';
     mode_changes[mode_count].dir = MODE_DEL;
     mode_changes[mode_count].caps = 0;
@@ -1691,16 +1828,20 @@
           char **parv, int *errors, int alev, int dir, char c, void *d,
           const char *chname)
 {
-  int i, limit;
+  int i, limit, admin = 0;
   char *lstr;
 
   if (alev < CHACCESS_HALFOP)
   {
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
+	}
   }
 
   if (dir == MODE_QUERY)
@@ -1722,6 +1863,9 @@
         mode_changes[i].letter = 0;
     }
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set +l %d on %s", source_p->name, limit, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_ADD;
     mode_changes[mode_count].caps = 0;
@@ -1739,6 +1883,9 @@
 
     chptr->mode.limit = 0;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set -l on %s", source_p->name, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_DEL;
     mode_changes[mode_count].caps = 0;
@@ -1755,16 +1902,20 @@
         char **parv, int *errors, int alev, int dir, char c, void *d,
         const char *chname)
 {
-  int i;
+  int i, admin = 0;
   char *key;
 
   if (alev < CHACCESS_HALFOP)
   {
+	if (IsOperRemote(source_p) && !ServicesOn) {
+	  admin = 1;
+	} else {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
+	}
   }
 
   if (dir == MODE_QUERY)
@@ -1789,6 +1940,9 @@
         mode_changes[i].letter = 0;
     }
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set +k %s on %s", source_p->name, chptr->mode.key, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_ADD;
     mode_changes[mode_count].caps = 0;
@@ -1807,6 +1961,9 @@
 
     *chptr->mode.key = 0;
 
+	if (admin)
+	  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s is using his admin flag to set -k on %s", source_p->name, chptr->chname);
+
     mode_changes[mode_count].letter = c;
     mode_changes[mode_count].dir = MODE_DEL;
     mode_changes[mode_count].caps = 0;
@@ -1831,17 +1988,17 @@
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},                             /* A */
   {chm_nosuch, NULL},                             /* B */
-  {chm_nosuch, NULL},                             /* C */
+  {chm_simple, (void *) MODE_NOCTCP},             /* s */
   {chm_nosuch, NULL},                             /* D */
   {chm_nosuch, NULL},                             /* E */
   {chm_nosuch, NULL},                             /* F */
   {chm_nosuch, NULL},                             /* G */
-  {chm_nosuch, NULL},                             /* H */
+  {chm_simple, (void *) MODE_NOSPAM},             /* H */
   {chm_invex, NULL},                              /* I */
   {chm_nosuch, NULL},                             /* J */
   {chm_nosuch, NULL},                             /* K */
   {chm_nosuch, NULL},                             /* L */
-  {chm_nosuch, NULL},                             /* M */
+  {chm_simple, (void *) MODE_NOTALK},             /* M */
   {chm_nosuch, NULL},                             /* N */
   {chm_nosuch, NULL},                             /* O */
   {chm_nosuch, NULL},                             /* P */
@@ -1867,7 +2024,7 @@
   {chm_nosuch, NULL},				  /* a */
 #endif
   {chm_ban, NULL},                                /* b */
-  {chm_nosuch, NULL},                             /* c */
+  {chm_simple, (void *) MODE_NOCOLOR},             /* s */
   {chm_nosuch, NULL},                             /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
@@ -1885,7 +2042,7 @@
   {chm_simple, (void *) MODE_NOPRIVMSGS},         /* n */
   {chm_op, NULL},                                 /* o */
   {chm_simple, (void *) MODE_PRIVATE},            /* p */
-  {chm_nosuch, NULL},                             /* q */
+  {chm_simple, (void *) MODE_JOINF},	          /* q */
   {chm_nosuch, NULL},                             /* r */
   {chm_simple, (void *) MODE_SECRET},             /* s */
   {chm_simple, (void *) MODE_TOPICLIMIT},         /* t */
@@ -1894,7 +2051,7 @@
   {chm_nosuch, NULL},                             /* w */
   {chm_nosuch, NULL},                             /* x */
   {chm_nosuch, NULL},                             /* y */
-  {chm_nosuch, NULL},                             /* z */
+  {chm_simple, (void *) MODE_NOREPEAT},           /* z */
 };
 /* *INDENT-ON* */
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/client.c ircd-hybrid-fuis/src/client.c
--- ircd-hybrid-7.0rc9/src/client.c	Sun Feb 16 17:54:37 2003
+++ ircd-hybrid-fuis/src/client.c	Sat Mar 22 18:55:33 2003
@@ -35,7 +35,6 @@
 #include "irc_string.h"
 #include "ircd.h"
 #include "list.h"
-#include "s_gline.h"
 #include "numeric.h"
 #include "packet.h"
 #include "s_auth.h"
@@ -458,96 +457,47 @@
 
     if (IsPerson(client_p))
     {
-      if (ConfigFileEntry.glines &&
-	  (aconf = find_gkill(client_p, client_p->username)))
-      {
-	if (IsExemptKline(client_p))
-	{
-	  sendto_realops_flags(FLAGS_ALL, L_ALL,
-		       "GLINE over-ruled for %s, client is kline_exempt",
-			       get_client_name(client_p, HIDE_IP));
-	  continue;
-	}
-	
-	if (IsExemptGline(client_p))
-	{
-	  sendto_realops_flags(FLAGS_ALL, L_ALL,
-			"GLINE over-ruled for %s, client is gline_exempt",
-			       get_client_name(client_p, HIDE_IP));
-	  continue;
-	}
-       
-	sendto_realops_flags(FLAGS_ALL, L_ALL, "GLINE active for %s",
-			     get_client_name(client_p, HIDE_IP));
-			    
-	if(ConfigFileEntry.kline_with_connection_closed &&
-	   ConfigFileEntry.kline_with_reason)
-	{
-	  reason = "Connection closed";
-
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
-		     me.name, client_p->name,
-		     aconf->passwd ? aconf->passwd : "G-lined");
-	} 
-	else 
-	{
-	  if(ConfigFileEntry.kline_with_connection_closed)
-	    reason = "Connection closed";
-	  else if(ConfigFileEntry.kline_with_reason && aconf->passwd)
-	    reason = aconf->passwd;
-	  else
-	    reason = "G-lined";
-
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
-		     me.name, client_p->name, reason);
-	}
-	
-	(void)exit_client(client_p, client_p, &me, reason);
-	/* and go examine next fd/client_p */    
-	continue;
-      } 
-      else if((aconf = find_kill(client_p)) != NULL) 
+	  if((aconf = find_kill(client_p)) != NULL) 
       {
-	/* if there is a returned struct ConfItem.. then kill it */
-	if (IsExemptKline(client_p))
-	{
-	  sendto_realops_flags(FLAGS_ALL, L_ALL,
-			     "KLINE over-ruled for %s, client is kline_exempt",
-			     get_client_name(client_p, HIDE_IP));
-	  continue;
-	}
+		/* if there is a returned struct ConfItem.. then kill it */
+		if (IsExemptKline(client_p))
+	    {
+		  sendto_realops_flags(FLAGS_ALL, L_ALL,
+				   "KLINE over-ruled for %s, client is kline_exempt",
+			  	   get_client_name(client_p, HIDE_IP));
+	  	  continue;
+		}
 
-	sendto_realops_flags(FLAGS_ALL, L_ALL, "KLINE active for %s",
+	  	sendto_realops_flags(FLAGS_ALL, L_ALL, "KLINE active for %s",
 			     get_client_name(client_p, HIDE_IP));
 	
-	if(ConfigFileEntry.kline_with_connection_closed &&
-	   ConfigFileEntry.kline_with_reason)
-	{
-	  reason = "Connection closed";
+		if(ConfigFileEntry.kline_with_connection_closed &&
+	     ConfigFileEntry.kline_with_reason)
+		{
+		  reason = "Connection closed";
 
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
-		     me.name, client_p->name, 
-		     aconf->passwd ? aconf->passwd : "K-lined");
-	}
-	else
-	{
-	  if(ConfigFileEntry.kline_with_connection_closed)
-	    reason = "Connection closed";
-	  else if(ConfigFileEntry.kline_with_reason && aconf->passwd)
-	    reason = aconf->passwd;
-	  else
-	    reason = "K-lined";
+		  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
+			     me.name, client_p->name, 
+			     aconf->passwd ? aconf->passwd : "K-lined");
+	    }
+  		else
+		{
+		  if(ConfigFileEntry.kline_with_connection_closed)
+	  		reason = "Connection closed";
+		  else if(ConfigFileEntry.kline_with_reason && aconf->passwd)
+	  		reason = aconf->passwd;
+		  else
+	  		reason = "K-lined";
 
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
-		     me.name, client_p->name, reason);
-	}
+		  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
+				     me.name, client_p->name, reason);
+		}
 	      
 	(void)exit_client(client_p, client_p, &me, reason);
 	continue; 
       }
-    }
   }
- 
+} 
   /* also check the unknowns list for new dlines */
   DLINK_FOREACH_SAFE(ptr, next_ptr, unknown_list.head)
   {
@@ -590,6 +540,8 @@
       --Count.oper;
     if (IsInvisible(client_p)) 
       --Count.invisi;
+	if (IsNSId(client_p) && ServicesOn)
+  	  --CurrentIdentUsers;  
   }
 
   if(splitchecking && !splitmode)
@@ -961,10 +913,35 @@
       }
 
       target_p = source_p->from;
-      if (target_p && IsServer(target_p) && target_p != client_p &&
-          !IsMe(target_p) && !IsKilled(source_p))
-        sendto_one(target_p, ":%s SQUIT %s :%s", from->name, source_p->name,
-                   comment);
+      if (target_p && IsServer(target_p) && target_p != client_p && !IsMe(target_p) &&
+          (!IsKilled(source_p)))
+        sendto_one(target_p, ":%s SQUIT %s :%s", from->name, source_p->name, comment);
+   else
+        sendto_realops_flags(FLAGS_EXTERNAL, L_ALL,
+            "Server %s dropped. Message from %s", source_p->name, from->name);
+
+     if (!irccmp(source_p->name, ConfigFileEntry.services_host))
+     {
+       struct Client *tmpptr;
+
+       ServicesOn = 0;
+        CurrentIdentUsers = 0;
+
+       sendto_realops_flags(FLAGS_EXTERNAL, L_ALL,
+         "Services (%s) become down", source_p->name);
+
+       for (tmpptr = GlobalClientList; tmpptr; tmpptr = tmpptr->next) {
+         if (IsServer(tmpptr) || IsMe(tmpptr))
+           continue;
+
+         if (IsNSId(tmpptr))
+           ClearNSId(tmpptr);
+         if (IsOSId(tmpptr))
+           ClearOSId(tmpptr);
+         if (IsNetKeeper(tmpptr))
+           ClearNetKeeper(tmpptr);
+    	}
+      }
     }
   else if (IsPerson(source_p)) /* ...just clean all others with QUIT... */
     {
@@ -1334,11 +1311,11 @@
 
     if (IsIpHash(source_p))
       remove_one_ip(&source_p->localClient->ip);
-    
+
     delete_adns_queries(source_p->localClient->dns_query);
     delete_identd_queries(source_p);
     client_flush_input(source_p);
-    
+
     /* This source_p could have status of one of STAT_UNKNOWN, STAT_CONNECTING
      * STAT_HANDSHAKE or STAT_UNKNOWN
      * all of which are lumped together into unknown_list
@@ -1358,7 +1335,7 @@
     if (IsClient(source_p))
     {
       Count.local--;
-      
+
       /* a little extra paranoia */
       if (IsPerson(source_p))
         dlinkDelete(&source_p->localClient->lclient_node, &lclient_list);
@@ -1386,19 +1363,19 @@
       else
         uplink = NULL;
     }
-    
+
     if (IsPerson(source_p))
       sendto_realops_flags(FLAGS_CCONN, L_ALL,
                            "Client exiting: %s (%s@%s) [%s] [%s]",
                            source_p->name, source_p->username, source_p->host,
-                           comment, 
+                           comment,
 #ifdef HIDE_SPOOF_IPS
                            IsIPSpoof(source_p) ? "255.255.255.255" :
 #endif
                            source_p->localClient->sockhost);
-    
+
     log_user_exit(source_p);
-  
+
     if (!IsDead(source_p))
     {
       if (client_p != NULL && source_p != client_p)
@@ -1408,7 +1385,6 @@
         sendto_one(source_p, "ERROR :Closing Link: %s (%s)",
                    source_p->host, comment);
     }
-
     /*
     ** Currently only server connections can have
     ** depending remote clients here, but it does no
@@ -1429,7 +1405,7 @@
   {
     if(ConfigServerHide.hide_servers)
     {
-      /* set netsplit message to "me.name *.split" to still show 
+      /* set netsplit message to "me.name *.split" to still show
        * that its a split, but hide the servers splitting
        */
       ircsprintf(comment1,"%s *.split", me.name);
@@ -1440,7 +1416,7 @@
         strcpy(comment1, source_p->serv->up);
       else
         strcpy(comment1, "<Unknown>");
-      
+
       strcat(comment1," ");
       strcat(comment1, source_p->name);
     }
@@ -1448,7 +1424,7 @@
     /* XXX Why does this happen */
     if (source_p->serv != NULL)
       remove_dependents(client_p, source_p, from, comment, comment1);
-    
+
     if (source_p->servptr == &me)
     {
       sendto_realops_flags(FLAGS_ALL, L_ALL,
@@ -1457,11 +1433,11 @@
                            source_p->localClient->sendK,
                            source_p->localClient->receiveK);
       ilog(L_NOTICE, "%s was connected for %d seconds.  %d/%d sendK/recvK.",
-           source_p->name, CurrentTime - source_p->firsttime, 
+           source_p->name, CurrentTime - source_p->firsttime,
            source_p->localClient->sendK, source_p->localClient->receiveK);
     }
   }
-  
+
   /* The client *better* be off all of the lists */
   assert(dlinkFind(&unknown_list, source_p) == NULL);
   assert(dlinkFind(&lclient_list, source_p) == NULL);
@@ -1727,6 +1703,11 @@
       return 0;
     }
 
+  if (IsNSId(source_p) && ServicesOn)
+   CurrentIdentUsers--;
+
+  ClearNSId(source_p);
+
   /* Finally, add to hash */
   del_from_client_hash_table(source_p->name, source_p);
   strcpy(source_p->name, nick);
@@ -1744,4 +1725,39 @@
   return 1;
 }
 
+static char cyr2lat[] = {
+  'A', 'B', 'V', 'G', 'D', 'E', 'Z', 'Z', 'I', 'J', 'K', 'L', 'M', 'N',
+  'O', 'P', 'R', 'S', 'T', 'U', 'F', 'H', 'C', '4', '6', '@', 'Y', '#',
+  'J', '#', 'U', 'Q',
+  'a', 'b', 'v', 'g', 'd', 'e', 'z', 'z', 'i', 'j', 'k', 'l', 'm', 'n',
+  'o', 'p', 'r', 's', 't', 'u', 'f', 'h', 'c', '4', '6', '@', 'y', '#',
+  'j', '#', 'u', 'q'
+};
+
+/*
+ * this will transpose cyrillic characters
+ * into their latin phonetic counterparts
+ *
+ *                                -demond
+ */
+char *translate(struct Client *client_p, char *buf)
+{
+  unsigned char *p = buf;
+  int offset;
+
+  if (IsSetTransWin(client_p))
+    offset = 192;
+  else if (IsSetTransISO(client_p))
+    offset = 176;
+  else
+    return buf;
 
+  while (*p)
+  {
+	if ((*p >= offset) && (*p < offset + 2*32))
+  	  *p = cyr2lat[*p - offset];
+    ++p;
+  }
+
+  return buf;
+}
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/descrip.mms ircd-hybrid-fuis/src/descrip.mms
--- ircd-hybrid-7.0rc9/src/descrip.mms	Thu May 23 18:20:15 2002
+++ ircd-hybrid-fuis/src/descrip.mms	Sun Feb 16 21:09:37 2003
@@ -13,7 +13,7 @@
 		HASH.OBJ,HOOK.OBJ,HOSTMASK.OBJ,IRC_STRING.OBJ,IRCD_SIGNAL.OBJ,LINEBUF.OBJ,LIST.OBJ,IRCD.OBJ,-
 		LISTENER.OBJ,M_ERROR.OBJ,MATCH.OBJ,MD5.OBJ,MEMORY.OBJ,MODULES.OBJ,MOTD.OBJ,NUMERIC.OBJ,PACKET.OBJ,-
 		PARSE.OBJ,RESTART.OBJ,RSA.OBJ,S_AUTH.OBJ,S_BSD.OBJ,S_BSD_SELECT.OBJ,S_CONF.OBJ,S_DEBUG.OBJ,-
-		S_GLINE.OBJ,S_LOG.OBJ,S_MISC.OBJ,S_SERV.OBJ,S_STATS.OBJ,S_USER.OBJ,SCACHE.OBJ,SEND.OBJ,SPRINTF_IRC.OBJ,-
+		S_LOG.OBJ,S_MISC.OBJ,S_SERV.OBJ,S_STATS.OBJ,S_USER.OBJ,SCACHE.OBJ,SEND.OBJ,SPRINTF_IRC.OBJ,-
 		VCHANNEL.OBJ,WHOWAS.OBJ,TOOLS.OBJ,RESV.OBJ,KDPARSE.OBJ,-
 		CHANNEL_MODE.OBJ,CRYPT.OBJ,BALLOC.OBJ,SNPRINTF.OBJ
 
